import{s as Ft,n as Dt,o as Ot}from"../chunks/scheduler.c59d9fbb.js";import{S as qt,i as zt,g as l,s as i,r as s,A as Nt,h as r,f as d,c as n,j as Bt,u as h,x as o,k as Pt,y as jt,a,v as f,d as m,t as g,w as p}from"../chunks/index.a47918e3.js";import{H as u}from"../chunks/Heading.604bc707.js";function Ut(vt){let c,U,N,V,b,J,$,wt=`🤗 PEFT, or Parameter-Efficient Fine-Tuning (PEFT), is a library for efficiently adapting pre-trained language models (PLMs) to various downstream applications without fine-tuning all the model’s parameters.
PEFT methods only fine-tune a small number of (extra) model parameters, significantly decreasing computational and storage costs because fine-tuning large-scale PLMs is prohibitively costly.
Recent state-of-the-art PEFT techniques achieve performance comparable to that of full fine-tuning.`,W,P,xt='PEFT is seamlessly integrated with 🤗 Accelerate for large-scale models leveraging DeepSpeed and <a href="https://huggingface.co/docs/accelerate/usage_guides/big_modeling" rel="nofollow">Big Model Inference</a>.',Z,T,Lt='<div class="w-full flex flex-col space-y-4 md:space-y-0 md:grid md:grid-cols-2 md:gap-y-4 md:gap-x-5"><a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="quicktour"><div class="w-full text-center bg-gradient-to-br from-blue-400 to-blue-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">Get started</div> <p class="text-gray-700">Start here if you&#39;re new to 🤗 PEFT to get an overview of the library&#39;s main features, and how to train a model with a PEFT method.</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="./task_guides/image_classification_lora"><div class="w-full text-center bg-gradient-to-br from-indigo-400 to-indigo-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">How-to guides</div> <p class="text-gray-700">Practical guides demonstrating how to apply various PEFT methods across different types of tasks like image classification, causal language modeling, automatic speech recognition, and more. Learn how to use 🤗 PEFT with the DeepSpeed and Fully Sharded Data Parallel scripts.</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="./conceptual_guides/lora"><div class="w-full text-center bg-gradient-to-br from-pink-400 to-pink-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">Conceptual guides</div> <p class="text-gray-700">Get a better theoretical understanding of how LoRA and various soft prompting methods help reduce the number of trainable parameters to make training more efficient.</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="./package_reference/config"><div class="w-full text-center bg-gradient-to-br from-purple-400 to-purple-500 rounded-lg py-1.5 font-semibold mb-5 text-white text-lg leading-relaxed">Reference</div> <p class="text-gray-700">Technical descriptions of how 🤗 PEFT classes and methods work.</p></a></div>',K,v,X,w,yt='<li>LoRA: <a href="https://arxiv.org/pdf/2106.09685.pdf" rel="nofollow">LORA: LOW-RANK ADAPTATION OF LARGE LANGUAGE MODELS</a></li> <li>Prefix Tuning: <a href="https://aclanthology.org/2021.acl-long.353/" rel="nofollow">Prefix-Tuning: Optimizing Continuous Prompts for Generation</a>, <a href="https://arxiv.org/pdf/2110.07602.pdf" rel="nofollow">P-Tuning v2: Prompt Tuning Can Be Comparable to Fine-tuning Universally Across Scales and Tasks</a></li> <li>P-Tuning: <a href="https://arxiv.org/pdf/2103.10385.pdf" rel="nofollow">GPT Understands, Too</a></li> <li>Prompt Tuning: <a href="https://arxiv.org/pdf/2104.08691.pdf" rel="nofollow">The Power of Scale for Parameter-Efficient Prompt Tuning</a></li> <li>AdaLoRA: <a href="https://arxiv.org/abs/2303.10512" rel="nofollow">Adaptive Budget Allocation for Parameter-Efficient Fine-Tuning</a></li> <li><a href="https://github.com/ZrrSkywalker/LLaMA-Adapter" rel="nofollow">LLaMA-Adapter: Efficient Fine-tuning of Language Models with Zero-init Attention</a></li> <li>IA3: <a href="https://arxiv.org/abs/2205.05638" rel="nofollow">Infused Adapter by Inhibiting and Amplifying Inner Activations</a></li>',Q,x,Y,L,At=`The tables provided below list the PEFT methods and models supported for each task. To apply a particular PEFT method for
a task, please refer to the corresponding Task guides.`,tt,y,et,A,Mt="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>GPT-2</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>Bloom</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>OPT</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-Neo</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-J</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-NeoX-20B</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>LLaMA</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>ChatGLM</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr></tbody>",dt,M,at,_,_t="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>T5</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>BART</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr></tbody>",it,E,nt,C,Et="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>BERT</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>RoBERTa</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td></tr> <tr><td>GPT-2</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>Bloom</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>OPT</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>GPT-Neo</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>GPT-J</td> <td>✅</td> <td>✅</td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>Deberta</td> <td>✅</td> <td></td> <td>✅</td> <td>✅</td> <td></td></tr> <tr><td>Deberta-v2</td> <td>✅</td> <td></td> <td>✅</td> <td>✅</td> <td></td></tr></tbody>",lt,H,rt,k,Ct="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>BERT</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>RoBERTa</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>GPT-2</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>Bloom</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>OPT</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>GPT-Neo</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>GPT-J</td> <td>✅</td> <td>✅</td> <td></td> <td></td> <td></td></tr> <tr><td>Deberta</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr> <tr><td>Deberta-v2</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",ot,R,st,S,Ht="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>Stable Diffusion</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",ht,I,ft,G,kt="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th> <th></th></tr></thead> <tbody><tr><td>ViT</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td> <td></td></tr> <tr><td>Swin</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",mt,B,gt,F,Rt=`We have tested LoRA for <a href="https://huggingface.co/docs/transformers/model_doc/vit" rel="nofollow">ViT</a> and <a href="https://huggingface.co/docs/transformers/model_doc/swin" rel="nofollow">Swin</a> for fine-tuning on image classification.
However, it should be possible to use LoRA for any <a href="https://huggingface.co/models?pipeline_tag=image-classification&amp;sort=downloads&amp;search=vit" rel="nofollow">ViT-based model</a> from 🤗 Transformers.
Check out the <a href="/task_guides/image_classification_lora">Image classification</a> task guide to learn more. If you run into problems, please open an issue.`,pt,D,St="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>Blip-2</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",ut,O,ct,q,It=`As with image-to-text models, you should be able to apply LoRA to any of the <a href="https://huggingface.co/models?pipeline_tag=image-segmentation&amp;sort=downloads" rel="nofollow">segmentation models</a>.
It’s worth noting that we haven’t tested this with every architecture yet. Therefore, if you come across any issues, kindly create an issue report.`,Tt,z,Gt="<thead><tr><th>Model</th> <th>LoRA</th> <th>Prefix Tuning</th> <th>P-Tuning</th> <th>Prompt Tuning</th> <th>IA3</th></tr></thead> <tbody><tr><td>SegFormer</td> <td>✅</td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",bt,j,$t;return b=new u({props:{title:"PEFT",local:"peft",headingTag:"h1"}}),v=new u({props:{title:"Supported methods",local:"supported-methods",headingTag:"h2"}}),x=new u({props:{title:"Supported models",local:"supported-models",headingTag:"h2"}}),y=new u({props:{title:"Causal Language Modeling",local:"causal-language-modeling",headingTag:"h3"}}),M=new u({props:{title:"Conditional Generation",local:"conditional-generation",headingTag:"h3"}}),E=new u({props:{title:"Sequence Classification",local:"sequence-classification",headingTag:"h3"}}),H=new u({props:{title:"Token Classification",local:"token-classification",headingTag:"h3"}}),R=new u({props:{title:"Text-to-Image Generation",local:"text-to-image-generation",headingTag:"h3"}}),I=new u({props:{title:"Image Classification",local:"image-classification",headingTag:"h3"}}),B=new u({props:{title:"Image to text (Multi-modal models)",local:"image-to-text-multi-modal-models",headingTag:"h3"}}),O=new u({props:{title:"Semantic Segmentation",local:"semantic-segmentation",headingTag:"h3"}}),{c(){c=l("meta"),U=i(),N=l("p"),V=i(),s(b.$$.fragment),J=i(),$=l("p"),$.textContent=wt,W=i(),P=l("p"),P.innerHTML=xt,Z=i(),T=l("div"),T.innerHTML=Lt,K=i(),s(v.$$.fragment),X=i(),w=l("ol"),w.innerHTML=yt,Q=i(),s(x.$$.fragment),Y=i(),L=l("p"),L.textContent=At,tt=i(),s(y.$$.fragment),et=i(),A=l("table"),A.innerHTML=Mt,dt=i(),s(M.$$.fragment),at=i(),_=l("table"),_.innerHTML=_t,it=i(),s(E.$$.fragment),nt=i(),C=l("table"),C.innerHTML=Et,lt=i(),s(H.$$.fragment),rt=i(),k=l("table"),k.innerHTML=Ct,ot=i(),s(R.$$.fragment),st=i(),S=l("table"),S.innerHTML=Ht,ht=i(),s(I.$$.fragment),ft=i(),G=l("table"),G.innerHTML=kt,mt=i(),s(B.$$.fragment),gt=i(),F=l("p"),F.innerHTML=Rt,pt=i(),D=l("table"),D.innerHTML=St,ut=i(),s(O.$$.fragment),ct=i(),q=l("p"),q.innerHTML=It,Tt=i(),z=l("table"),z.innerHTML=Gt,bt=i(),j=l("p"),this.h()},l(t){const e=Nt("svelte-u9bgzb",document.head);c=r(e,"META",{name:!0,content:!0}),e.forEach(d),U=n(t),N=r(t,"P",{}),Bt(N).forEach(d),V=n(t),h(b.$$.fragment,t),J=n(t),$=r(t,"P",{"data-svelte-h":!0}),o($)!=="svelte-1xarjzd"&&($.textContent=wt),W=n(t),P=r(t,"P",{"data-svelte-h":!0}),o(P)!=="svelte-ouajxs"&&(P.innerHTML=xt),Z=n(t),T=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(T)!=="svelte-1ffe0tg"&&(T.innerHTML=Lt),K=n(t),h(v.$$.fragment,t),X=n(t),w=r(t,"OL",{"data-svelte-h":!0}),o(w)!=="svelte-1m7g6zz"&&(w.innerHTML=yt),Q=n(t),h(x.$$.fragment,t),Y=n(t),L=r(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-1c93f6z"&&(L.textContent=At),tt=n(t),h(y.$$.fragment,t),et=n(t),A=r(t,"TABLE",{"data-svelte-h":!0}),o(A)!=="svelte-trn6pz"&&(A.innerHTML=Mt),dt=n(t),h(M.$$.fragment,t),at=n(t),_=r(t,"TABLE",{"data-svelte-h":!0}),o(_)!=="svelte-6w2sxz"&&(_.innerHTML=_t),it=n(t),h(E.$$.fragment,t),nt=n(t),C=r(t,"TABLE",{"data-svelte-h":!0}),o(C)!=="svelte-jb5iad"&&(C.innerHTML=Et),lt=n(t),h(H.$$.fragment,t),rt=n(t),k=r(t,"TABLE",{"data-svelte-h":!0}),o(k)!=="svelte-8nh2hv"&&(k.innerHTML=Ct),ot=n(t),h(R.$$.fragment,t),st=n(t),S=r(t,"TABLE",{"data-svelte-h":!0}),o(S)!=="svelte-1ert2bf"&&(S.innerHTML=Ht),ht=n(t),h(I.$$.fragment,t),ft=n(t),G=r(t,"TABLE",{"data-svelte-h":!0}),o(G)!=="svelte-13cqscq"&&(G.innerHTML=kt),mt=n(t),h(B.$$.fragment,t),gt=n(t),F=r(t,"P",{"data-svelte-h":!0}),o(F)!=="svelte-w4w7ox"&&(F.innerHTML=Rt),pt=n(t),D=r(t,"TABLE",{"data-svelte-h":!0}),o(D)!=="svelte-3x98tj"&&(D.innerHTML=St),ut=n(t),h(O.$$.fragment,t),ct=n(t),q=r(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-179ftdd"&&(q.innerHTML=It),Tt=n(t),z=r(t,"TABLE",{"data-svelte-h":!0}),o(z)!=="svelte-jb5pa9"&&(z.innerHTML=Gt),bt=n(t),j=r(t,"P",{}),Bt(j).forEach(d),this.h()},h(){Pt(c,"name","hf:doc:metadata"),Pt(c,"content",Vt),Pt(T,"class","mt-10")},m(t,e){jt(document.head,c),a(t,U,e),a(t,N,e),a(t,V,e),f(b,t,e),a(t,J,e),a(t,$,e),a(t,W,e),a(t,P,e),a(t,Z,e),a(t,T,e),a(t,K,e),f(v,t,e),a(t,X,e),a(t,w,e),a(t,Q,e),f(x,t,e),a(t,Y,e),a(t,L,e),a(t,tt,e),f(y,t,e),a(t,et,e),a(t,A,e),a(t,dt,e),f(M,t,e),a(t,at,e),a(t,_,e),a(t,it,e),f(E,t,e),a(t,nt,e),a(t,C,e),a(t,lt,e),f(H,t,e),a(t,rt,e),a(t,k,e),a(t,ot,e),f(R,t,e),a(t,st,e),a(t,S,e),a(t,ht,e),f(I,t,e),a(t,ft,e),a(t,G,e),a(t,mt,e),f(B,t,e),a(t,gt,e),a(t,F,e),a(t,pt,e),a(t,D,e),a(t,ut,e),f(O,t,e),a(t,ct,e),a(t,q,e),a(t,Tt,e),a(t,z,e),a(t,bt,e),a(t,j,e),$t=!0},p:Dt,i(t){$t||(m(b.$$.fragment,t),m(v.$$.fragment,t),m(x.$$.fragment,t),m(y.$$.fragment,t),m(M.$$.fragment,t),m(E.$$.fragment,t),m(H.$$.fragment,t),m(R.$$.fragment,t),m(I.$$.fragment,t),m(B.$$.fragment,t),m(O.$$.fragment,t),$t=!0)},o(t){g(b.$$.fragment,t),g(v.$$.fragment,t),g(x.$$.fragment,t),g(y.$$.fragment,t),g(M.$$.fragment,t),g(E.$$.fragment,t),g(H.$$.fragment,t),g(R.$$.fragment,t),g(I.$$.fragment,t),g(B.$$.fragment,t),g(O.$$.fragment,t),$t=!1},d(t){t&&(d(U),d(N),d(V),d(J),d($),d(W),d(P),d(Z),d(T),d(K),d(X),d(w),d(Q),d(Y),d(L),d(tt),d(et),d(A),d(dt),d(at),d(_),d(it),d(nt),d(C),d(lt),d(rt),d(k),d(ot),d(st),d(S),d(ht),d(ft),d(G),d(mt),d(gt),d(F),d(pt),d(D),d(ut),d(ct),d(q),d(Tt),d(z),d(bt),d(j)),d(c),p(b,t),p(v,t),p(x,t),p(y,t),p(M,t),p(E,t),p(H,t),p(R,t),p(I,t),p(B,t),p(O,t)}}}const Vt='{"title":"PEFT","local":"peft","sections":[{"title":"Supported methods","local":"supported-methods","sections":[],"depth":2},{"title":"Supported models","local":"supported-models","sections":[{"title":"Causal Language Modeling","local":"causal-language-modeling","sections":[],"depth":3},{"title":"Conditional Generation","local":"conditional-generation","sections":[],"depth":3},{"title":"Sequence Classification","local":"sequence-classification","sections":[],"depth":3},{"title":"Token Classification","local":"token-classification","sections":[],"depth":3},{"title":"Text-to-Image Generation","local":"text-to-image-generation","sections":[],"depth":3},{"title":"Image Classification","local":"image-classification","sections":[],"depth":3},{"title":"Image to text (Multi-modal models)","local":"image-to-text-multi-modal-models","sections":[],"depth":3},{"title":"Semantic Segmentation","local":"semantic-segmentation","sections":[],"depth":3}],"depth":2}],"depth":1}';function Jt(vt){return Ot(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xt extends qt{constructor(c){super(),zt(this,c,Jt,Ut,Ft,{})}}export{Xt as component};
